package com.eactive.eai.batch.job.jobItem.fiusc;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;
import com.eactive.eai.batch.running.BatchOpenFileManager;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_FIUSC_0303 extends DefaultTelegram implements TelegramService
{

    private FileInputStream fin ;
    private File file;
    private int  SEQUENCE_NO;
    private int  REAL_BYTE;              // 실 data byte수
    private int  SEND_LENGTH;            //길이 필드를 제외한 전문의 총길이
    private int  REAL_SEND_LENGTH;       //실제 송신할 전문의 총길이( SEND_LENGTH + 길이필드 길이)

    private Properties telegramInfo;
    private byte[] fileData;

    /**
     * 생성자
     */
    public SEND_FIUSC_0303() {
        //파일 데이터 송신
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = setData();
            if (!result) {
                return false;
            }
            result = calculateSendLength();
            if (!result) return false;

            int i = -1;
            //전문송신  전체 Byte 수
            compileField(++i, ""+REAL_SEND_LENGTH, this.al_FieldProps[i]);
            
            // Transaction Code
            compileField(++i, telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE), this.al_FieldProps[i]);

            // 시스템명칭 (FIU)
            compileField(++i, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[i]);
            
            // 참가기관코드
            compileField(++i, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[i]);
            
            //사용자ID
            byte[] userId = new byte[20];
            Arrays.fill(userId, (byte)' ');
            
            // checked file에서 가져온 사용자 ID
        	String fileHeaderInfo = batchDoc.getBatchMsg().getHeader().getHdrInfoName();
        	fileHeaderInfo = fileHeaderInfo.substring(38);
            String checkedFileUserId = fileHeaderInfo.substring(SEND_FIUSC_HEAD.USER_ID.getStrPos(),SEND_FIUSC_HEAD.USER_ID.getEndPos());
            System.arraycopy(checkedFileUserId.getBytes(), 0, userId, 0, Math.min(checkedFileUserId.getBytes().length, 20));

            al_Field.set(++i, userId);
            
            //전문종별코드.
            compileField(++i, this.getFldTelegramType()+ this.getFldOpCode() + "0", this.al_FieldProps[i]);
            
            //송수신 FLAG : 전문 발생 기관을 구분하여  아래의 값을 SET한다.
            compileField(++i, getFldTrClass(), this.al_FieldProps[i]);

            //기관구분
            compileField(++i, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[i]);

            //계속여부
            compileField(++i, "Y", this.al_FieldProps[i]);

            //응답코드
            compileField(++i, getSendResponseCode(), this.al_FieldProps[i]);
            // 여기 까지 공통부
            
            //시퀀스번호
            compileField(++i, ""+SEQUENCE_NO, this.al_FieldProps[i]);
            
            //기송신 크기
            compileField(++i, ""+(batchDoc.getBatchMsg().getBody().getCurFileSize()- REAL_BYTE), this.al_FieldProps[i]);
            
            //실 DATA BYTE 수
            compileField(++i, ""+REAL_BYTE, this.al_FieldProps[i]);
            
            //<< XX를 제외한 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }
    }

    public int getInformalFieldSendData(int idx, byte[] data) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < REAL_BYTE) {
                logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            //data = fileData;
            ByteArrayInputStream bin = new ByteArrayInputStream(fileData);
            bin.read(data, 0, REAL_BYTE);
            return REAL_BYTE;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return -1;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;

        try {
			//DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<10; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=10; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return false;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;

            //BATCH작업구분코드 (processCode)에 따른 프로퍼티 정보 가져오기
            telegramInfo = getTelegramInfo();
            
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return -1;
        }
    }

    /**
     * 비정형 필드에 대한 송신 길이를 계산해서 리턴해준다.
     *
     * 필드(idx)가 비정형 필드(XX)인지 점검하고 , 해당 필드에 대한 예상 길이를 계산하여 리턴하도록 한다
     *
     * 비정현 필드를 가지고 있는 개별 Telegram Class 에서 오버라이드 필요.
     */
    public int getCalculatedLength(int idx) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
               return REAL_BYTE;
            } else {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI012";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                logger.debug("{} getCalculatedLength> parameter is not FIELD_NO_LENGTH", logHeader);
                return -1;
            }
        }catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI005";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return -1;
        }
    }


    private boolean createFile ()
    {

    	fin = BatchOpenFileManager.getInstance().getFile(batchDoc.getBatchMsg().getHeader().getUUID() );

    	try {
            String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
            String fileNm  = batchDoc.getBatchMsg().getHeader().getRenamedFileName();

            if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                fileDir = fileDir + this.getSeparator();
            }

            String fileName = fileDir + fileNm;
            file = new File(fileName);
            if (!file.exists()) // 파일이 없으면 리턴 False
            {
                logger.debug("{} the File["+fileDir+"/"+file.getName()+"] does not exist!!!", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = fileName;
                String errCode = "BECEAIFJI022";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return false;
            }

            if ( fin == null) {
            	fin = new FileInputStream(file);
                BatchOpenFileManager.getInstance().addFile(batchDoc.getBatchMsg().getHeader().getUUID() , fileName, fin);
            }
            
            logger.info("{} File [" + file.getName() + "] Size =" + file.length(), logHeader);
            
            return true;
            
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }

    }

    private boolean setData ()
    {
        try {
            if (!createFile()) {
                logger.info("{}  file open failed", logHeader);
                return false;
            }

            int sequence_size = this.batchDoc.getBatchMsg().getHeader().getSequenceSize();
            int block_size = this.batchDoc.getBatchMsg().getHeader().getBlockSize();
            int seq_no = this.batchDoc.getBatchMsg().getBody().getSeqNum();
            SEQUENCE_NO = seq_no + 1;

            // 블럭 크기에 도달하면 BLOCKEND 하여 다음 03000040전문으로 넘어가게 함
            if (( this.SEQUENCE_NO % block_size) == 0 ) { 
                this.setConditionTxt(TelegramKeys.BLOCKEND);
            }
            
            // 파일 크기에 도달하면 EOF하여 파일확인(0304/0314)전문 수행 후 업무종료 
            if (batchDoc.getBatchMsg().getBody().getCurFileSize() + sequence_size >= batchDoc.getBatchMsg().getHeader().getFileSize()) {
                this.setConditionTxt(TelegramKeys.BLOCKEND);
            }

            // 저장된 메모리 정보 참조 하기
            JobProcessData job = JobProcessData.getInstance();
            String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
            HashMap<String, Object> hm = job.getBatchStageData(uuid);

            @SuppressWarnings("unchecked")
			HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>) hm.get(JobProcessData.PROCDATA_BLOCKDATA);
            if (block_data == null) {
                block_data = new HashMap<Integer, byte[]>();
            }

        	fileData = block_data.get(new Integer(SEQUENCE_NO-1));

        	if ( fileData == null ){
                fileData = new byte[sequence_size];
                REAL_BYTE = fin.read(fileData);
                
                if (REAL_BYTE < sequence_size) {
                	ByteArrayInputStream bin = new ByteArrayInputStream(fileData);
                	byte[] retryFileData = new byte[REAL_BYTE];
                	int bytesRead = bin.read(retryFileData);
                	if (bytesRead == REAL_BYTE) {
                		block_data.put(new Integer(SEQUENCE_NO-1),  retryFileData);
                	}
                } else {
                	block_data.put(new Integer(SEQUENCE_NO-1),  fileData);
                }
                hm.put(JobProcessData.PROCDATA_BLOCKDATA, block_data);

            } else {
            	REAL_BYTE = fileData.length;  // 재처리
            }

        	// 전송 상태 처리
            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize() + REAL_BYTE;
            batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);
        	
            this.batchDoc.getBatchMsg().getBody().setSeqNum(SEQUENCE_NO);

            return true;
        } catch (Exception e ) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI029";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size()-1; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += REAL_BYTE;
            REAL_SEND_LENGTH = SEND_LENGTH + ((byte[]) this.al_Field.get(0)).length;

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
    	String telegramNo = super.getFieldValueString(5);
    	if ( telegramNo.length() < 8 ) return "";
		return telegramNo.substring(0,3) + telegramNo.substring(6,7);
    }

    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(9);
    }

}
